<?php

namespace JimsGroup\Datatypes;

/**
 * Class FinalizeBookingRequestType
 */
class FinalizeBookingRequestType extends Datatype
{
    use DataTypeTrait;

    protected $default = [
        'bookingRequestId' => 0,
        'allocate_confirm_codes' => 0,
        'brandSource' => 'Jims',
        'choosedProviderId' => 0,
        'confirmed_not_previous_client' => true,
        'countryCode' => 'AU',
        'division_id' => 0,
        'id' => null,
        'ipAddress' => '',
        'jimsProperty' => 'CB',
        'jimsProvider' => 'Jims',
        'otherServices' => 'CB_Transfer',
        'providerInfo' => null,
        'selectedServicesIds' => [],
        'userInfo' => [],
        'utmCampaign' => '',
        'utmContent' => '',
        'utmMedium' => '',
        'utmSource' => '',
        'utmTerm' => '',
        'previousLeadId' => 0,
    ];


    public function setBookingRequestId($bookingRequestId)
    {
        $this->data['bookingRequestId'] = $bookingRequestId;
    }

    /**
     * @param array $providerInfo
     * @return void
     */
    public function setProviderInfo(array $providerInfo)
    {
        $this->data['providerInfo'] = new ProviderInfo($providerInfo);
    }

    public function setUserInfo($address, $addressString, $allow_rating, $comments, $isUserInfoConfirmed, $emailAddress, $firstName, $lastName, $phoneNumber, $subscribed, $businessName)
    {
        $this->data['userInfo'] = new UserInfo([
            'address' => $address,
            'addressString' => $addressString,
            'allow_rating' => $allow_rating,
            'comments' => $comments,
            'isUserInfoConfirmed' => $isUserInfoConfirmed,
            'emailAddress' => $emailAddress,
            'firstName' => $firstName,
            'lastName' => $lastName,
            'phoneNumber' => $phoneNumber,
            'subscribed' => $subscribed,
            'businessName' => $businessName
        ]);;
    }

    public function getAllocateConfirmCodes(): int
    {
        return $this->allocate_confirm_codes;
    }

    public function setBrandSource(string $brandSource): void
    {
        $this->data['brandSource'] = $brandSource;
    }

    public function getBrandSource(): string
    {
        return $this->brandSource;
    }

    public function getChoosedProviderId(): int
    {
        return $this->choosedProviderId;
    }

    public function setConfirmedNotPreviousClient(bool $confirmed_not_previous_client): void
    {
        $this->data['confirmed_not_previous_client'] = $confirmed_not_previous_client;
    }

    public function getConfirmedNotPreviousClient(): bool
    {
        return $this->confirmed_not_previous_client;
    }

    public function getCountryCode(): string
    {
        return $this->countryCode;
    }

    public function getDivisionId(): int
    {
        return $this->division_id;
    }

    public function getId(): int
    {
        return $this->id;
    }

    public function getIpAddress(): string
    {
        return $this->ipAddress;
    }

    public function getJimsProperty(): string
    {
        return $this->jimsProperty;
    }

    public function getJimsProvider(): string
    {
        return $this->jimsProvider;
    }

    public function getOtherServices(): string
    {
        return $this->otherServices;
    }

    public function getProviderInfo(): ?ProviderInfo
    {
        return $this->providerInfo;
    }

    public function getSelectedServicesIds(): array
    {
        return $this->selectedServicesIds;
    }

    public function getUserInfo(): array
    {
        return $this->userInfo;
    }

    public function getPreviousLeadId(): int
    {
        return $this->previousLeadId;
    }


}